#include <QtGui>

#include "list.h"

List::List(QWidget *parent)
	: QListWidget(parent)
{
	setDragEnabled(true);
	setAcceptDrops(true);
	setViewMode(QListView::ListMode);
	setSpacing(1);
	//setFixedWidth(80);
	//setFixedHeight(100);

	initItems();
}
void List::initItems()
{
	QIcon icon = qApp->style()->standardIcon(QStyle::SP_DriveDVDIcon);

	p_li1 = new QListWidgetItem(icon,"Text" , this);
	p_li2 = new QListWidgetItem(icon,"Table", this);	
	new QListWidgetItem("qwe",this);//  
	new QListWidgetItem("qwe",this);
	new QListWidgetItem("qwe",this);
	new QListWidgetItem("qwe",this);
	new QListWidgetItem("qwe",this);
	new QListWidgetItem("qwe",this);
	new QListWidgetItem("qwe",this);
}
void List::dragEnterEvent(QDragEnterEvent *event)
{
	if (event->mimeData()->hasFormat("elemtext")){
		if (event->source() == this){
			event->ignore();
		} else {
			event->proposedAction();
		}
	} else {
		event->ignore();
	}
}
void List::dragMoveEvent(QDragMoveEvent *event)
{
	if (event->mimeData()->hasFormat("elemtext")){
		if (event->source() == this){
			event->ignore();
		} else {
			event->proposedAction();
		}
	} else {
		event->ignore();
	}
}
void List::mousePressEvent(QMouseEvent *event)
{
	QLabel *child = static_cast<QLabel*>(childAt(event->pos()));
	if(!child)
		return;

	QPixmap pixmap = *child->pixmap();
	//QPixmap pixmap = QPixmap(":/images/house.png");
	
	QByteArray itemData;
	QDataStream dataStream(&itemData, QIODevice::WriteOnly);
	dataStream << pixmap << QPoint(event->pos() - child->pos());

	QMimeData *mimeData = new QMimeData;
	mimeData->setData("elemtext",itemData);

	QDrag *drag = new QDrag(this);
	drag->setMimeData(mimeData);
	drag->setPixmap(pixmap);
	drag->setHotSpot(event->pos() - child->pos());

	if ( drag->exec(Qt::CopyAction | Qt::MoveAction, Qt::CopyAction ) == Qt::MoveAction )
		child->close();
	else {
		child->show();
		child->setPixmap(pixmap);
	}
}