#include <QtGui>

#include "mainwindow.h"
#include "list.h"
#include "editwidget.h"

MainWindow::MainWindow(QWidget *parent)
	:QMainWindow(parent)
{
	setupMenus();
	setupWidgets();
	setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed));
	setWindowTitle(tr("Shablon editor"));
}

void MainWindow::setupMenus()
{
	QMenu *fileMenu = menuBar()->addMenu(tr("&File"));
	
	QAction *exitAction = fileMenu->addAction(tr("E&xit"));
	exitAction->setShortcut(QKeySequence(tr("Ctrl+Q")));
	
	connect(exitAction, SIGNAL(triggered()) , qApp , SLOT(quit()));
}
void MainWindow::setupWidgets()
{
	QFrame *frame = new QFrame;
	QHBoxLayout *frameLayout= new QHBoxLayout(frame);
	
	editor = new EditWidget;
	frameLayout->addWidget(editor);
	
	QVBoxLayout *rightLayout = new QVBoxLayout();
	elemList = new List;
	rightLayout->addWidget(elemList);
	elemList1 = new List;				//  
	rightLayout->addWidget(elemList1); //  

	frameLayout->addLayout(rightLayout);


	setCentralWidget(frame);
}